Subject: Re: [GIT PULL] ARM: SoC fixes for v5.10, part 3

From: Russell King - ARM Linux admin <[email-masked]>
Date: Mon, 30 Nov 2020 19:06:34 +0000

On Mon, Nov 30, 2020 at 10:15:29AM -0800, Linus Torvalds wrote:
> On Mon, Nov 30, 2020 at 10:05 AM Russell King - ARM Linux admin
> <[email-masked]> wrote:
> >
> > If you think that /dev/sda for example is always the machine's internal
> > HDD, that is wrong.
> 
> Yes. See the whole part about
> 
>  "Note that it really is only the internal devices that matter. Once you
>   start plugging in an external USB hug and random devices, ordering
>   clearly won't be reliable.
> 
>   So this is not a "everything must be ordered". But people who think
>   that that then means "everythinbg can be random" are wrong"
> 
> in my email.
> 
> And the key word here is:
> 
> > I have a HP Pavilion laptop with its internal HDD with a Windows
> > installation. Because I didn't want to destroy that in any way, I
> > bought an external USB3 SATA enclosure and SSD, and installed Debian
> > Stable on there.
> 
> .. but it will still generally be stable with the same hardware
> configuration, and not fluctuate randomly from boot to boot when the
> hardware is the same.
> 
> Is it a guarantee? No. External plugged in hardware can change things.
> In fact, when you have things like Thunderbolt involved, since it just
> looks like PCI, even the PCI probing order won't be the same with or
> without the plugged-in device.
> 
> But again: avoid randomness. The difference between non-random and
> random is that one is predictable and one is not.
> 
> Predictability is good. It's not necessariyl always achievable, but
> it's very much something we should strive for VERY HARD.
> 
> Predictability and reproducibility help debugging enormously. It means
> that things like "git bisect" work a lot better. It makes user reports
> much more understandable when two users with identical hardware see
> identical issues.
> 
> Seriously. Anybody who argues against reproducibility is so far out to
> lunch that it's not even funny.
> 
> You seem to argue on a complete technicality.

Yes, I fully agree - but the problem is that how people read your
"avoid randomness".

Randomness as in "doesn't change if I change kernel configuration"
or "doesn't change order on reboot to a similar kernel".

People who have complained about mmc in the past have done so from
the point of view of "I changed something, now my mmc block devices
are different".

It is my understanding that mmc behaves in the same way as exactly
what I see on my HP laptop. The device numbering is stable provided
the hardware (and indeed software) configuration is stable.

If I decide to rebuild the Debian kernel for my HP laptop, and build
in the drivers necessary for all its hardware, the internal HDD will
switch to being /dev/sda instead of /dev/sdb as it is now... which
doesn't seem to be any different from complaints like "I've changed
some code in the kernel now my MMC devices have changed order."

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 40Mbps down 10Mbps up. Decent connectivity at last!

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel